commit:     6133f24b7aa014b37f3df585a93e7a95d8f60a33
Author:     Nicolas Bock <nicolasbock <AT> gentoo <DOT> org>
AuthorDate: Fri Apr 15 07:37:27 2016 +0000
Commit:     Nicolas Bock <nicolasbock <AT> gentoo <DOT> org>
CommitDate: Fri Apr 15 07:38:09 2016 +0000
URL:        https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=6133f24b

sci-physics/lammps: Version bump

Package-Manager: portage-2.2.26

 sci-physics/lammps/Manifest               |   1 +
 sci-physics/lammps/lammps-20160314.ebuild | 218 ++++++++++++++++++++++++++++++
 2 files changed, 219 insertions(+)

diff --git a/sci-physics/lammps/Manifest b/sci-physics/lammps/Manifest
index 1dc83a1..116b59f 100644
--- a/sci-physics/lammps/Manifest
+++ b/sci-physics/lammps/Manifest
@@ -3,6 +3,7 @@ DIST lammps-10Feb15.tar.gz 62912048 SHA256 
59373e9b5592f7b697a144bbce1fb742726e0
 DIST lammps-10Mar16.tar.gz 88637744 SHA256 
b40d79d4a8490a549dc46f259ce65095d75e78059b002083eb899825e802c1ac SHA512 
b850c9f9826cd7f4db2d922c9ee1bc8302ea5cf92200f56e5aa834850f690ee8e17dca6e431651ccfded34bd79e2b8e50cfb2e7de3bd93359279f06bb8704424
 WHIRLPOOL 
283e74dd90454a79119ac9d69bc61ba44d0a23fd18455286faea5867f018e69d9ce593d06c6940e7e7f9f89cdaee7c83ff592a7a8816fdcab703c25a9c65f28b
 DIST lammps-11Dec15.tar.gz 82386057 SHA256 
f95cce2efa5f9d5649de22c19c96281f3af7b0f65a1f051a268131fe526542d9 SHA512 
dce3c29811ee25b8404774b69d7e9746535bed5c4ae9a1c21aaf6979e411bb4b777ca95a4f788d16f6093785e074dbc5275c2d99b1c1d6a28aa0706069855a77
 WHIRLPOOL 
a0b7fcf202745d22511ced803c8bc55b0487a8cdb2c32a0c9a121569a7e5641b072ccbcc70ef7a1529da736d6166d6d2afd80769fc84fc4f07af25b023710a57
 DIST lammps-11Sep15.tar.gz 87274144 SHA256 
79a40bc395a9052345cf1c7caa8da69f6ec0603e0be09503b060c51672a9734f SHA512 
a478470d6e90c870dad606649009c085451d3890632dfc05a84890ff9d69e8465eff52d4853b4dc4a82ebcb15074c8f2fd07bbde132404a01c1c5df0867ee3f2
 WHIRLPOOL 
21225df1baadd02dbdc9f0b7aea6a2323ac1a1ac177453b67d5387b87a711e505395d17efada9ca5d079d919842da69c6d41d9a3a6ec6375d8526c3ed32f8ad3
+DIST lammps-14Mar16.tar.gz 88642225 SHA256 
79b7f3e75d553a86c7bf3ffbb8305fd0fe92f6a57d634b983b6a31816a72dabb SHA512 
5ba774165ea4957fc3f33c91b96ff7b5e2ab498b6979d7887d5e7dfd464e3c830edffcc341e93fc8dcdb89f3eadd683c0893d4a8d2664ad469aa79ddc39c21b7
 WHIRLPOOL 
ecafe88e06839ce506dba86a30a8548fd6b5771155e4d4c9b42932573ad932854fdecff80299c62ab529d2cfd97147ed3bcdf7ffe034e266914b078ac8708510
 DIST lammps-15Jan16.tar.gz 85956338 SHA256 
e90816bf20622200f5037415e5c45a0f950f7407886121708b794b1e75b93c3a SHA512 
7dc2043afba78ec8d61b5880b6123952b42e5076fe7e3c3855186215054bc28710b89fd5b015d495fcfe38d5970efd43f3e6e834e80f39b6305b551d39f5eeab
 WHIRLPOOL 
13bd3f41047492035c24e11d47b36ec8565d226738be492159ba498827c79eab4a7ec7402e037820b635b0d8d4c56fbdedea482f2f93e370275d717c93bc281c
 DIST lammps-15May15.tar.gz 63835027 SHA256 
0233ea98c7d77d31bd0a538bb674c0ee8f000f1d0ee1b8c049072873192aa228 SHA512 
a23c16b98117590b15ca7662b878fb2f76ec41399c329c98deb48e28a0ffce293443269513a96c2503389894b598787b19dadc210d4b4dbc6a7432caf633e7d1
 WHIRLPOOL 
4c4edfd772bbf534e42fc43e1feaf3b8f76e74c58ec1e985e3c29ee0d8e64aa8c501b8e45e078643409c320a1d834b0d5eb699e7d1ec29df06be0126d12492f1
 DIST lammps-1Mar16.tar.gz 87945422 SHA256 
af2bd7ab2a28aa14b8afa3d8703cbaf27d924400e237bf44e9e2da091c0b91eb SHA512 
25b59f840187053a9f47bc41f5d0b29a69ac507e05528fb3e84c2bb8facd90fff95e99cbd8707c8d087371355a2e1c5af1eb3e4115b788444af5d129e754fe9d
 WHIRLPOOL 
b45f4ca459a88770c6d194f609f55694bdb50b7a54cf57a34995e4d3f6f0b432f99fdd9c7187c8e614a98b31387bfcc259baa9218f2c3bb5e146991c3a113207

diff --git a/sci-physics/lammps/lammps-20160314.ebuild 
b/sci-physics/lammps/lammps-20160314.ebuild
new file mode 100644
index 0000000..08762c3
--- /dev/null
+++ b/sci-physics/lammps/lammps-20160314.ebuild
@@ -0,0 +1,218 @@
+# Copyright 1999-2016 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+# $Id$
+
+EAPI=5
+
+PYTHON_COMPAT=( python{2_7,3_3,3_4} )
+
+inherit eutils flag-o-matic fortran-2 multilib python-r1
+
+convert_month() {
+       local months=( "" Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec )
+       echo ${months[${1#0}]}
+}
+
+MY_P=${PN}-$((10#${PV:6:2}))$(convert_month ${PV:4:2})${PV:2:2}
+
+DESCRIPTION="Large-scale Atomic/Molecular Massively Parallel Simulator"
+HOMEPAGE="http://lammps.sandia.gov/";
+SRC_URI="http://lammps.sandia.gov/tars/${MY_P}.tar.gz";
+
+LICENSE="GPL-2"
+SLOT="0"
+KEYWORDS="~amd64 ~x86"
+IUSE="doc examples gzip lammps-memalign mpi python static-libs"
+
+# blas/lapack is needed by the ATC package which is only built with MPI.
+DEPEND="
+       gzip? ( app-arch/gzip )
+       mpi? (
+               virtual/blas
+               virtual/lapack
+               virtual/mpi
+       )
+       python? ( ${PYTHON_DEPS} )
+       sci-libs/voro++
+       "
+RDEPEND="${DEPEND}"
+
+REQUIRED_USE="python? ( ${PYTHON_REQUIRED_USE} )"
+
+S="${WORKDIR}/${MY_P}"
+
+lmp_emake() {
+       local LAMMPS_INCLUDEFLAGS
+       LAMMPS_INCLUDEFLAGS="$(usex gzip '-DLAMMPS_GZIP' '')"
+       LAMMPS_INCLUDEFLAGS+="$(usex lammps-memalign ' -DLAMMPS_MEMALIGN=64' 
'')"
+
+       # The lammps makefile uses CC to indicate the C++ compiler.
+       emake \
+               ARCHIVE="$(tc-getAR)" \
+               CC="$(usex mpi "mpic++" "$(tc-getCXX)")" \
+               F90="$(usex mpi "mpif90" "$(tc-getFC)")" \
+               LINK="$(usex mpi "mpic++" "$(tc-getCXX)")" \
+               CCFLAGS="${CXXFLAGS}" \
+               F90FLAGS="${FCFLAGS}" \
+               LINKFLAGS="${LDFLAGS}" \
+               LMP_INC="${LAMMPS_INCLUDEFLAGS}" \
+               MPI_INC="$(usex mpi "" "-I../STUBS")" \
+               MPI_PATH="$(usex mpi "" "-L../STUBS")" \
+               MPI_LIB="$(usex mpi "" "-lmpi_stubs")" \
+               user-atc_SYSLIB="$(usex mpi "$($(tc-getPKG_CONFIG) --libs blas) 
$($(tc-getPKG_CONFIG) --libs lapack)" '')"\
+               "$@"
+}
+
+lmp_activate_packages() {
+       # Build packages
+       local packages=( yes-asphere yes-body yes-class2 yes-colloid \
+               yes-coreshell yes-dipole yes-fld yes-granular yes-kspace \
+               yes-manybody yes-mc yes-meam yes-misc \
+               $(usex mpi "yes-user-atc" "") \
+               yes-molecule yes-opt yes-peri yes-poems yes-qeq yes-reax \
+               yes-replica yes-rigid yes-shock yes-snap yes-srd \
+               yes-user-eff yes-user-fep \
+               $(usex mpi "yes-user-lb" "") \
+               yes-user-phonon yes-user-sph yes-voronoi yes-xtc )
+
+       for p in ${packages[@]}; do
+               lmp_emake -C src ${p}
+       done
+}
+
+lmp_build_packages() {
+       lmp_emake -C lib/meam -j1 -f Makefile.gfortran
+       lmp_emake -C lib/poems -f Makefile.g++
+       lmp_emake -C lib/reax -j1 -f Makefile.gfortran
+       use mpi && lmp_emake -C lib/atc -f Makefile.g++
+}
+
+lmp_clean_packages() {
+       lmp_emake -C lib/meam -f Makefile.gfortran clean
+       lmp_emake -C lib/poems -f Makefile.g++ clean
+       lmp_emake -C lib/reax -f Makefile.gfortran clean
+       use mpi && lmp_emake -C lib/atc -f Makefile.g++ clean
+}
+
+src_prepare() {
+       # Fix inconsistent use of SHFLAGS.
+       sed -i \
+               -e 's:voronoi_SYSINC\s\+=.*$:voronoi_SYSINC = 
-I/usr/include/voro++:' \
+               -e 's:voronoi_SYSPATH\s\+=.*$:voronoi_SYSPATH =:' \
+               lib/voronoi/Makefile.lammps || die
+
+       # Fix missing .so name.
+       sed -i \
+               -e 's:SHLIBFLAGS\s\+=\s\+:SHLIBFLAGS = 
-Wl,-soname,liblammps.so.0 :' \
+               src/MAKE/Makefile.serial || die
+
+       # Fix makefile in tools.
+       sed -i \
+               -e 's:g++:$(CXX) $(CXXFLAGS):' \
+               -e 's:gcc:$(CC) $(CCFLAGS):' \
+               -e 's:ifort:$(FC) $(FCFLAGS):' \
+               tools/Makefile || die
+
+       # Patch python.
+       epatch "${FILESDIR}/lammps-python3-r2.patch"
+       epatch "${FILESDIR}/python-shebang.patch"
+}
+
+src_compile() {
+       # Fix atc...
+       append-cxxflags -I../../src
+
+       # Acticate packages.
+       elog "Activating lammps packages..."
+       lmp_activate_packages
+
+       # STUBS/mpi.c is using '#include <mpi.h>' now instead of '#include
+       # "mpi.h"' which requires an additional '-I.'.
+       append-cxxflags -I.
+
+       # Compile stubs for serial version.
+       use mpi || lmp_emake -C src mpi-stubs
+
+       elog "Building packages..."
+       lmp_build_packages
+
+       if use static-libs; then
+               # Build static library.
+               elog "Building static library..."
+               lmp_emake -C src mode=lib serial
+       fi
+
+       # Clean out packages (that's not done by the build system with the clean
+       # target), so we can rebuild the packages with -fPIC.
+       elog "Cleaning packages..."
+       lmp_clean_packages
+
+       # The build system does not rebuild the packages with -fPIC, adding flag
+       # manually.
+       append-cxxflags -fPIC
+       append-fflags -fPIC
+
+       # Compile stubs for serial version.
+       use mpi || lmp_emake -C src mpi-stubs
+
+       elog "Building packages..."
+       lmp_build_packages
+
+       # Build shared library.
+       elog "Building shared library..."
+       lmp_emake -C src mode=shlib serial
+
+       # Compile main executable. The shared library is always built, and
+       # mode=shexe is simply a way to re-use the object files built in the
+       # "shlib" step when linking the executable. The executable is not 
actually
+       # using the shared library. If we have built the static library, then we
+       # link that into the executable.
+       elog "Linking executable..."
+       if use static-libs; then
+               lmp_emake -C src mode=exe serial
+       else
+               lmp_emake -C src mode=shexe serial
+       fi
+
+       # Compile tools.
+       elog "Building tools..."
+       lmp_emake -C tools binary2txt chain data2xmovie micelle2d
+}
+
+src_install() {
+       use static-libs && newlib.a src/liblammps_serial.a liblammps.a
+       newlib.so src/liblammps_serial.so liblammps.so.0.0.0
+       dosym liblammps.so.0.0.0 /usr/$(get_libdir)/liblammps.so
+       dosym liblammps.so.0.0.0 /usr/$(get_libdir)/liblammps.so.0
+       newbin src/lmp_serial lmp
+       dobin tools/binary2txt
+       dobin tools/chain
+       dobin tools/data2xmovie
+       dobin tools/micelle2d
+       # Don't forget to add header files of optional packages as they are 
added
+       # to this ebuild. There may also be .mod files from Fortran based
+       # packages.
+       insinto "/usr/include/${PN}"
+       doins -r src/*.h lib/meam/*.mod
+
+       local LAMMPS_POTENTIALS="usr/share/${PN}/potentials"
+       insinto "/${LAMMPS_POTENTIALS}"
+       doins potentials/*
+       echo "LAMMPS_POTENTIALS=${EROOT}${LAMMPS_POTENTIALS}" > 99lammps
+       doenvd 99lammps
+
+       # Install python script.
+       use python && python_foreach_impl python_domodule python/lammps.py
+
+       if use examples; then
+               local LAMMPS_EXAMPLES="/usr/share/${PN}/examples"
+               insinto "${LAMMPS_EXAMPLES}"
+               doins -r examples/*
+       fi
+
+       dodoc README
+       if use doc; then
+               dodoc doc/Manual.pdf
+               dohtml -r doc/*
+       fi
+}

Reply via email to